###################################################
### chunk number 1: 
###################################################
library(solaR)
oopt <- options() 
options("digits"=4) 
options("width"=80)


###################################################
### chunk number 2: 
###################################################
#Calculo para un único día 

lat=37.2; 
Nm=1 #Numero de muestras por hora
SolD<-fSolD(lat,dn=100)
print(SolD)
SolI<-fSolI(SolD,Nm=Nm)
print(SolI[7:18,8:12])


###################################################
### chunk number 3: 
###################################################
#Calculo para un varios días

SolD<-fSolD(lat,dn=c(10,50,100))
print(SolD)


###################################################
### chunk number 4: 
###################################################
SolD<-fSolD(lat,BTd=fBTd(Modo='DiasProm')) 
SolI<-fSolI(SolD,Nm=6)
print(SolD)


###################################################
### chunk number 5: 
###################################################
NombreMes=format(ISOdate(2000, 1:12, 1), "%b") 
p<-xyplot(AlS*180/pi~AzS*180/pi, groups=factor(NombreMes[Mes]),data=SolI,col='black', type='l', xlab=expression(psi[s]),ylab=expression(gamma[s])) 
print(direct.label(p,method='top.points'))


###################################################
### chunk number 6: 
###################################################
BTd=fBTd(Modo='Serie')
SolD<-fSolD(lat,BTd=BTd)
summary(SolD)


###################################################
### chunk number 7: 
###################################################
p<-xyplot(decl~DiaAno,data=SolD,type='l')
print(p)


###################################################
### chunk number 8: 
###################################################
SolD<-fSolD(lat,dn=100) 
G0d=5000 
CompD<-fCompD(SolD,G0d, corr = "Page")
dif=!(names(CompD) %in% names(SolD))
print(CompD[dif])


###################################################
### chunk number 9: 
###################################################
G0dm=c(2.766,3.491,4.494,5.912,6.989,7.742,7.919,7.027,5.369,3.562,2.814,2.179)*1000; 
SolD<-fSolD(lat,BTd=fBTd(Modo='DiasProm'))  
CompD<-fCompD(SolD,G0d=G0dm, corr = 'Page')
dif=!(names(CompD) %in% names(SolD)) 
summary(CompD[dif])


###################################################
### chunk number 10: 
###################################################
SolI<-fSolI(SolD,Nm=6) 
CompI<-fCompI(CompD,SolI)
dif=!(names(CompI) %in% names(SolI))
summary(CompI[dif])


###################################################
### chunk number 11: 
###################################################
p<-xyplot(G0+B0+D0~w|Mes,data=CompI,type='l',auto.key=list(space='right'))
print(p)


###################################################
### chunk number 12: 
###################################################
data(RedEstaciones)
Madrid<-subset(RedEstaciones,NomProv=='Madrid')
print(Madrid)


###################################################
### chunk number 13: 
###################################################
Aranjuez<-LeeMAPA(28,3,'01/01/2009','31/12/2009')
summary(Aranjuez)


###################################################
### chunk number 14: 
###################################################
lat=41; 
BTd=fBTd(Modo='BaseDatos',FechaBaseDatos=Aranjuez$Fecha,FormatoFecha="%d/%m/%Y") 
BD<-cbind(BTd,Aranjuez)
SolD<-fSolD(lat,BTd=BTd) 
SolI<-fSolI(SolD,Nm=1)
Temp<-fTemp(SolI,BD)


###################################################
### chunk number 15: 
###################################################
p<-bwplot(Ta~w|Mes,data=Temp,horizontal=FALSE, outline=FALSE)
print(p)


###################################################
### chunk number 16: 
###################################################
MAPA=list(Provincia=28,Estacion=3,FechaInicio='01/01/2009',FechaFinal='31/12/2009')
Rad0<-calcG0(lat=41,modoRad='mapa',MAPA=MAPA)
#Parametros
Rad0$param


###################################################
### chunk number 17: 
###################################################
summary(Rad0$D)


###################################################
### chunk number 18: 
###################################################
summary(Rad0$I[18:30])


###################################################
### chunk number 19: 
###################################################

SolD<-fSolD(lat=41,BTd=fBTd(Modo='DiasProm')) 
SolI<-fSolI(SolD,Nm=6)
AngGenHoriz<-fTheta(SolI,modoSeg='horiz',BT=TRUE,
           distancias=data.frame(Leo=10),
           estruct=list(L=4),BetaLim=60);


###################################################
### chunk number 20: 
###################################################
p<-xyplot(Beta~w,data=AngGenHoriz,type='l')
print(p)


###################################################
### chunk number 21: 
###################################################
#por defecto, modoSeg='est' y alfa=0
AngGen<-fTheta(SolI,beta=35)
Inclin<-fInclin(CompI, AngGen)


###################################################
### chunk number 22: 
###################################################
p<-xyplot(Gef/G~cosTheta,data=Inclin)
print(p)


###################################################
### chunk number 23: 
###################################################
Inclin=data.frame(Gef=c(200,400,600,800,1000),Ta=25)
modulo = list(Vocn = 57.6, Iscn = 4.7, Vmn = 46.08, Imn = 4.35, Ncs = 96, Ncp = 1, CoefVT = 0.0023, TONC = 47)
generador = list(Nms = 12, Nmp = 11)
inversor = list(Ki = c(0.01, 0.025, 0.05), Pinv = 25000, Vmin = 420, Vmax = 750, Gumb = 20)
EffSys = list(ModQual = 3, ModDisp = 2, OhmDC = 1.5, OhmAC = 1.5, MPP = 1, TrafoMT = 1, Disp = 0.5)
Prod<-fProd(Inclin,modulo,generador,inversor,EffSys)
print(Prod)


###################################################
### chunk number 24: 
###################################################
Inclin=data.frame(Gef=800,Ta=30)
generador = list(Nms = 10, Nmp = 11)
Prod<-fProd(Inclin,generador=generador)
print(Prod)


###################################################
### chunk number 25: 
###################################################
with(Prod,Vdc*Idc/(Vmpp*Impp))


###################################################
### chunk number 26: 
###################################################
lat=37.2;
G0dm=c(2766, 3491, 4494, 5912, 6989, 7742, 7919, 7027, 5369, 3562, 2814, 2179)
ProdEst<-prodSFCR(lat=lat,G0dm=G0dm) 
Prod2x<-prodSFCR(lat=lat,G0dm=G0dm,modoSeg='doble') 
ProdHoriz<-prodSFCR(lat=lat,G0dm=G0dm,modoSeg='horiz')


###################################################
### chunk number 27: 
###################################################
ComparePac<-data.frame(doble=Prod2x$I$Pac,horiz=ProdHoriz$I$Pac, est=ProdEst$I$Pac, w=ProdEst$I$w,Mes=ProdEst$I$Mes)
p<-xyplot(doble+horiz+est~w|Mes,data=ComparePac,type='l',auto.key=list(space='right'),ylab='Pac')
print(p)


###################################################
### chunk number 28: 
###################################################
lat=37.2; 
G0dm=c(2.766,3.491,4.494,5.912,6.989,7.742,7.919,7.027,5.369,3.562,2.814,2.179)*1000; 
SolD<-fSolD(lat,BTd=fBTd(Modo='DiasProm')) 
SolI<-fSolI(SolD,Nm=6) 
CompD<-fCompD(SolD,G0d=G0dm, corr = 'Page') 
CompD$Ta=25 
CompI<-fCompI(CompD,SolI) 
AngGen<-fTheta(SolI,beta=35);


###################################################
### chunk number 29: 
###################################################
distancias=data.frame(Leo=40,Lns=30,H=0) 
estruct=list(W=23.11, L=9.8, Nfilas=2, Ncol=8)
FactorSombra<-fSombra6(AngGen,distancias, estruct,prom=FALSE)
p<-xyplot(FS~w,groups=Mes, data=FactorSombra, type='l',auto.key=list(space='right'))
print(p)


###################################################
### chunk number 30: 
###################################################
distancias=data.frame(Leo=c(-40,0,40,-40,40),Lns=c(30,30,30,0,0),H=0) 
FactorSombra2<-fSombra6(AngGen,distancias, estruct,prom=FALSE)
identical(FactorSombra,FactorSombra2)


###################################################
### chunk number 31: 
###################################################
###2x
Prod2xSombra<-prodSFCR(lat=lat,G0dm=G0dm,modoSeg='doble', modoSombra='area', distancias=data.frame(Leo=40,Lns=40,H=0))
###Eje horizontal NS sin backtracking 
estruct=list(L=4.83)
distancias=data.frame(Leo=estruct$L*4,H=0)
ProdHorizSombra<-prodSFCR(lat=lat,G0dm=G0dm, Nm=6, modoSeg='horiz', modoSombra='area', BetaLim=60, distancias=distancias, estruct=estruct)
###Eje horizontal NS con backtracking 
ProdHorizBT<-prodSFCR(lat=lat,G0dm=G0dm, Nm=6, modoSeg='horiz', modoSombra='bt', BetaLim=60, distancias=distancias, estruct=estruct)


###################################################
### chunk number 32: 
###################################################
lat=37.2;
G0dm=c(2766, 3491, 4494, 5912, 6989, 7742, 7919, 7027, 5369, 3562, 2814, 2179) 


###################################################
### chunk number 33: 
###################################################
estruct=list(L=4.83); 
distancias=list(Leo=estruct$L*c(2,5));
Sombra12Horiz<-optimSombra(lat=lat,G0dm=G0dm, modoSeg='horiz', BetaLim=60, distancias=distancias, res=2, estruct=estruct, modoSombra='area',prog=FALSE)
class(Sombra12Horiz)


###################################################
### chunk number 34: 
###################################################
plot(Sombra12Horiz)


###################################################
### chunk number 35: 
###################################################
estruct=list(L=5); 
distancias=list(D=estruct$L*c(1,3)); 
Sombra12Est<-optimSombra(lat=lat,G0dm=G0dm, modoSeg='est', modoSombra='area', distancias=distancias, res=1, estruct=estruct,prog=FALSE)


###################################################
### chunk number 36: 
###################################################
plot(Sombra12Est)


###################################################
### chunk number 37: 
###################################################
estruct=list(W=23.11, L=9.8, Nfilas=2, Ncol=8)


###################################################
### chunk number 38: 
###################################################
distancias=list(Leo=c(30,50),Lns=c(20,50))


###################################################
### chunk number 39: 
###################################################
SombraM2x<-optimSombra(lat=lat,G0dm=G0dm, modoSeg='doble', modoSombra=c('area','prom'), distancias=distancias, res=5, prog=FALSE)
summary(SombraM2x$S)


###################################################
### chunk number 40: 
###################################################
plot(SombraM2x)


###################################################
### chunk number 41: 
###################################################
data(CoefBomba) 
CoefSP8A44<-subset(CoefBomba,Qn==8&Etapas==44)
fSP8A44<-fBomba(Bomba=CoefSP8A44,H=40)


###################################################
### chunk number 42: 
###################################################
SP8A44=with(fSP8A44,{
    Pac=seq(lim[1],lim[2],by=100); 
    Pb=fPb(Pac); 
    etam=Pb/Pac; 
    Ph=fPh(Pac); 
    etab=Ph/Pb; 
    f=fFrecuencia(Pac); 
    Caudal=fCaudal(Pac); 
    result=data.frame(Caudal,Pac,Pb,Ph,etam,etab,f)})
SP8A44$etamb=with(SP8A44,etab*etam)


###################################################
### chunk number 43: 
###################################################
p<-xyplot(etam+etab+etamb~Pac,data=SP8A44,type='l') 
print(direct.label(p, method = "top.points")) 


###################################################
### chunk number 44: 
###################################################
p<-xyplot(Pb+Ph~Pac,data=SP8A44,type='l') 
print(direct.label(p))


###################################################
### chunk number 45: 
###################################################
Pg=seq(3000,5500,by=500) 
H=seq(60,80,by=5) 
Bomba=list(Qn=8,Etapas=44) 
NmgSP8A44<-NmgSFB(Bomba=Bomba,Pg=Pg,H=H,Gd=6000)
print(NmgSP8A44$dibujo)


###################################################
### chunk number 46: 
###################################################
lat=37.2 
G0dm=c(2766, 3491, 4494, 5912, 6989, 7742, 7919, 7027, 5369, 3562, 2814, 2179) 

Bomba=list(Qn=8,Etapas=44) 

prodSP8A44<-prodSFB(lat,G0dm,Bomba=Bomba,H=50,Pg=5500) 

print(prodSP8A44$D) 


###################################################
### chunk number 47: 
###################################################
prodSP8A44Lim<-prodSFB(lat,G0dm,Bomba=Bomba,H=50,Pg=7000)  


###################################################
### chunk number 48: 
###################################################
p<-xyplot(Q~Gef|Mes,type='l',data=prodSP8A44$I)
print(p)


###################################################
### chunk number 49: 
###################################################
p<-xyplot(Q~Gef|Mes,type='l',data=prodSP8A44Lim$I)
print(p)


